Class: CamundaClient
Constructors
Constructor
new CamundaClient(opts?): CamundaClient;
Parameters
opts?
CamundaOptions = {}
Returns
CamundaClient
Accessors
config
Get Signature
get config(): Readonly<CamundaConfig>;
Returns
Readonly<CamundaConfig>
Methods
_getSupportLogger()
_getSupportLogger(): SupportLogger;
Internal accessor for support logger (no public API commitment yet).
Returns
_invokeWithRetry()
_invokeWithRetry<T>(op, opts): Promise<T>;
Internal invocation helper to apply global backpressure gating + retry + normalization
Type Parameters
T
T
Parameters
op
() => Promise<T>
opts
classify?
(e) => object
exempt?
boolean
opId
string
retryOverride?
| false
| Partial<HttpRetryPolicy>
Returns
Promise<T>
activateAdHocSubProcessActivities()
activateAdHocSubProcessActivities(input, options?): CancelablePromise<void>;
Activate activities within an ad-hoc sub-process
Activates selected activities within an ad-hoc sub-process identified by element ID. The provided element IDs must exist within the ad-hoc sub-process instance identified by the provided adHocSubProcessInstanceKey.
Parameters
input
activateAdHocSubProcessActivitiesInput
options?
Returns
CancelablePromise<void>
Example
async function activateAdHocSubProcessActivitiesExample(
adHocSubProcessInstanceKey: ElementInstanceKey,
elementId: ElementId
) {
const camunda = createCamundaClient();
await camunda.activateAdHocSubProcessActivities({
adHocSubProcessInstanceKey,
elements: [{ elementId }],
});
}
Operation Id
activateAdHocSubProcessActivities
Tags
Ad-hoc sub-process
activateJobs()
activateJobs(input, options?): CancelablePromise<{
jobs: EnrichedActivatedJob[];
}>;
Activate jobs
Iterate through all known partitions and activate jobs up to the requested maximum.
Parameters
input
options?
Returns
CancelablePromise<{
jobs: EnrichedActivatedJob[];
}>
Example
async function activateJobsExample() {
const camunda = createCamundaClient();
const result = await camunda.activateJobs({
type: "payment-processing",
timeout: 30000,
maxJobsToActivate: 5,
});
for (const job of result.jobs) {
console.log(`Job ${job.jobKey}: ${job.type}`);
// Each enriched job has helper methods
await job.complete({ paymentId: "PAY-123" });
}
}
Operation Id
activateJobs
Tags
Job
assignClientToGroup()
assignClientToGroup(input, options?): CancelablePromise<void>;
Assign a client to a group
Assigns a client to a group, making it a member of the group. Members of the group inherit the group authorizations, roles, and tenant assignments.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignClientToGroupExample() {
const camunda = createCamundaClient();
await camunda.assignClientToGroup({
groupId: "engineering-team",
clientId: "my-service-account",
});
}
Operation Id
assignClientToGroup
Tags
Group
assignClientToTenant()
assignClientToTenant(input, options?): CancelablePromise<void>;
Assign a client to a tenant
Assign the client to the specified tenant. The client can then access tenant data and perform authorized actions.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignClientToTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.assignClientToTenant({
tenantId,
clientId: "my-service-account",
});
}
Operation Id
assignClientToTenant
Tags
Tenant
assignGroupToTenant()
assignGroupToTenant(input, options?): CancelablePromise<void>;
Assign a group to a tenant
Assigns a group to a specified tenant. Group members (users, clients) can then access tenant data and perform authorized actions.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignGroupToTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.assignGroupToTenant({
tenantId,
groupId: "engineering-team",
});
}
Operation Id
assignGroupToTenant
Tags
Tenant
assignMappingRuleToGroup()
assignMappingRuleToGroup(input, options?): CancelablePromise<void>;
Assign a mapping rule to a group
Assigns a mapping rule to a group.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignMappingRuleToGroupExample() {
const camunda = createCamundaClient();
await camunda.assignMappingRuleToGroup({
groupId: "engineering-team",
mappingRuleId: "rule-123",
});
}
Operation Id
assignMappingRuleToGroup
Tags
Group
assignMappingRuleToTenant()
assignMappingRuleToTenant(input, options?): CancelablePromise<void>;
Assign a mapping rule to a tenant
Assign a single mapping rule to a specified tenant.
Parameters
input
assignMappingRuleToTenantInput
options?
Returns
CancelablePromise<void>
Example
async function assignMappingRuleToTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.assignMappingRuleToTenant({
tenantId,
mappingRuleId: "rule-123",
});
}
Operation Id
assignMappingRuleToTenant
Tags
Tenant
assignRoleToClient()
assignRoleToClient(input, options?): CancelablePromise<void>;
Assign a role to a client
Assigns the specified role to the client. The client will inherit the authorizations associated with this role.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignRoleToClientExample() {
const camunda = createCamundaClient();
await camunda.assignRoleToClient({
roleId: "process-admin",
clientId: "my-service-account",
});
}
Operation Id
assignRoleToClient
Tags
Role
assignRoleToGroup()
assignRoleToGroup(input, options?): CancelablePromise<void>;
Assign a role to a group
Assigns the specified role to the group. Every member of the group (user or client) will inherit the authorizations associated with this role.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignRoleToGroupExample() {
const camunda = createCamundaClient();
await camunda.assignRoleToGroup({
roleId: "process-admin",
groupId: "engineering-team",
});
}
Operation Id
assignRoleToGroup
Tags
Role
assignRoleToMappingRule()
assignRoleToMappingRule(input, options?): CancelablePromise<void>;
Assign a role to a mapping rule
Assigns a role to a mapping rule.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignRoleToMappingRuleExample() {
const camunda = createCamundaClient();
await camunda.assignRoleToMappingRule({
roleId: "process-admin",
mappingRuleId: "rule-123",
});
}
Operation Id
assignRoleToMappingRule
Tags
Role
assignRoleToTenant()
assignRoleToTenant(input, options?): CancelablePromise<void>;
Assign a role to a tenant
Assigns a role to a specified tenant. Users, Clients or Groups, that have the role assigned, will get access to the tenant's data and can perform actions according to their authorizations.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignRoleToTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.assignRoleToTenant({
tenantId,
roleId: "process-admin",
});
}
Operation Id
assignRoleToTenant
Tags
Tenant
assignRoleToUser()
assignRoleToUser(input, options?): CancelablePromise<void>;
Assign a role to a user
Assigns the specified role to the user. The user will inherit the authorizations associated with this role.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignRoleToUserExample(username: Username) {
const camunda = createCamundaClient();
await camunda.assignRoleToUser({
roleId: "process-admin",
username,
});
}
Operation Id
assignRoleToUser
Tags
Role
assignUserTask()
assignUserTask(input, options?): CancelablePromise<void>;
Assign user task
Assigns a user task with the given key to the given assignee. Assignment waits for blocking task listeners on this lifecycle transition. If listener processing is delayed beyond the request timeout, this endpoint can return 504. Other gateway timeout causes are also possible. Retry with backoff and inspect listener worker availability and logs when this repeats.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignUserTaskExample(userTaskKey: UserTaskKey) {
const camunda = createCamundaClient();
await camunda.assignUserTask({
userTaskKey,
assignee: "alice",
allowOverride: true,
});
}
Operation Id
assignUserTask
Tags
User task
assignUserToGroup()
assignUserToGroup(input, options?): CancelablePromise<void>;
Assign a user to a group
Assigns a user to a group, making the user a member of the group. Group members inherit the group authorizations, roles, and tenant assignments.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignUserToGroupExample(username: Username) {
const camunda = createCamundaClient();
await camunda.assignUserToGroup({
groupId: "engineering-team",
username,
});
}
Operation Id
assignUserToGroup
Tags
Group
assignUserToTenant()
assignUserToTenant(input, options?): CancelablePromise<void>;
Assign a user to a tenant
Assign a single user to a specified tenant. The user can then access tenant data and perform authorized actions.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function assignUserToTenantExample(
tenantId: TenantId,
username: Username
) {
const camunda = createCamundaClient();
await camunda.assignUserToTenant({
tenantId,
username,
});
}
Operation Id
assignUserToTenant
Tags
Tenant
broadcastSignal()
broadcastSignal(input, options?): CancelablePromise<SignalBroadcastResult>;
Broadcast signal
Broadcasts a signal.
Parameters
input
options?
Returns
CancelablePromise<SignalBroadcastResult>
Example
async function broadcastSignalExample() {
const camunda = createCamundaClient();
const result = await camunda.broadcastSignal({
signalName: "system-shutdown",
variables: {
reason: "Scheduled maintenance",
},
});
console.log(`Signal broadcast key: ${result.signalKey}`);
}
Operation Id
broadcastSignal
Tags
Signal
cancelBatchOperation()
cancelBatchOperation(input, options?): CancelablePromise<void>;
Cancel Batch operation
Cancels a running batch operation. This is done asynchronously, the progress can be tracked using the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
batchOperationKey
options?
Returns
CancelablePromise<void>
Example
async function cancelBatchOperationExample(
batchOperationKey: BatchOperationKey
) {
const camunda = createCamundaClient();
await camunda.cancelBatchOperation({ batchOperationKey });
}
Operation Id
cancelBatchOperation
Tags
Batch operation
cancelProcessInstance()
cancelProcessInstance(input, options?): CancelablePromise<void>;
Cancel process instance
Cancels a running process instance. As a cancellation includes more than just the removal of the process instance resource, the cancellation resource must be posted. Cancellation can wait on listener-related processing; when that processing does not complete in time, this endpoint can return 504. Other gateway timeout causes are also possible. Retry with backoff and inspect listener worker availability and logs when this repeats.
Parameters
input
object & object
options?
Returns
CancelablePromise<void>
Example
async function cancelProcessInstanceExample(
processDefinitionId: ProcessDefinitionId
) {
const camunda = createCamundaClient();
// Create a process instance and get its key from the response
const created = await camunda.createProcessInstance({
processDefinitionId,
});
// Cancel the process instance using the key from the creation response
await camunda.cancelProcessInstance({
processInstanceKey: created.processInstanceKey,
});
}
Operation Id
cancelProcessInstance
Tags
Process instance
cancelProcessInstancesBatchOperation()
cancelProcessInstancesBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Cancel process instances (batch)
Cancels multiple running process instances. Since only ACTIVE root instances can be cancelled, any given filters for state and parentProcessInstanceKey are ignored and overridden during this batch operation. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
ProcessInstanceCancellationBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function cancelProcessInstancesBatchOperationExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const result = await camunda.cancelProcessInstancesBatchOperation({
filter: {
processDefinitionKey,
},
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
cancelProcessInstancesBatchOperation
Tags
Process instance
clearAuthCache()
clearAuthCache(opts?): void;
Parameters
opts?
disk?
boolean
memory?
boolean
Returns
void
completeJob()
completeJob(input, options?): CancelablePromise<void>;
Complete job
Complete a job with the given payload, which allows completing the associated service task.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function completeJobExample(jobKey: JobKey) {
const camunda = createCamundaClient();
await camunda.completeJob({
jobKey,
variables: {
paymentId: "PAY-123",
status: "completed",
},
});
}
Operation Id
completeJob
Tags
Job
completeUserTask()
completeUserTask(input, options?): CancelablePromise<void>;
Complete user task
Completes a user task with the given key. Completion waits for blocking task listeners on this lifecycle transition. If listener processing is delayed beyond the request timeout, this endpoint can return 504. Other gateway timeout causes are also possible. Retry with backoff and inspect listener worker availability and logs when this repeats.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function completeUserTaskExample(userTaskKey: UserTaskKey) {
const camunda = createCamundaClient();
await camunda.completeUserTask({
userTaskKey,
variables: {
approved: true,
comment: "Looks good",
},
});
}
Operation Id
completeUserTask
Tags
User task
configure()
configure(next): void;
Parameters
next
Returns
void
correlateMessage()
correlateMessage(input, options?): CancelablePromise<MessageCorrelationResult>;
Correlate message
Publishes a message and correlates it to a subscription. If correlation is successful it will return the first process instance key the message correlated with. The message is not buffered. Use the publish message endpoint to send messages that can be buffered.
Parameters
input
options?
Returns
CancelablePromise<MessageCorrelationResult>
Example
async function correlateMessageExample() {
const camunda = createCamundaClient();
const result = await camunda.correlateMessage({
name: "order-payment-received",
correlationKey: "ORD-12345",
variables: {
paymentId: "PAY-123",
amount: 99.95,
},
});
console.log(`Message correlated to: ${result.processInstanceKey}`);
}
Operation Id
correlateMessage
Tags
Message
createAdminUser()
createAdminUser(input, options?): CancelablePromise<UserCreateResult>;
Create admin user
Creates a new user and assigns the admin role to it. This endpoint is only usable when users are managed in the Orchestration Cluster and while no user is assigned to the admin role.
Parameters
input
options?
Returns
CancelablePromise<UserCreateResult>
Example
async function createAdminUserExample(username: Username) {
const camunda = createCamundaClient();
const result = await camunda.createAdminUser({
username,
name: "Admin User",
email: "admin@example.com",
password: "admin-password-123",
});
console.log(`Created admin user: ${result.username}`);
}
Operation Id
createAdminUser
Tags
Setup
createAuthorization()
createAuthorization(input, options?): CancelablePromise<AuthorizationCreateResult>;
Create authorization
Create the authorization.
Parameters
input
| AuthorizationIdBasedRequest
| AuthorizationPropertyBasedRequest
options?
Returns
CancelablePromise<AuthorizationCreateResult>
Example
async function createAuthorizationExample() {
const camunda = createCamundaClient();
const result = await camunda.createAuthorization({
ownerId: "user-123",
ownerType: "USER",
resourceId: "order-process",
resourceType: "PROCESS_DEFINITION",
permissionTypes: ["CREATE_PROCESS_INSTANCE", "READ_PROCESS_INSTANCE"],
});
console.log(`Authorization key: ${result.authorizationKey}`);
}
Operation Id
createAuthorization
Tags
Authorization
createDeployment()
createDeployment(input, options?): CancelablePromise<ExtendedDeploymentResult>;
Deploy resources
Deploys one or more resources (e.g. processes, decision models, or forms). This is an atomic call, i.e. either all resources are deployed or none of them are.
Parameters
input
options?
Returns
CancelablePromise<ExtendedDeploymentResult>
Enriched deployment result with typed arrays (processes, decisions, decisionRequirements, forms, resources).
Example
async function deployResourcesFromFilesExample() {
const camunda = createCamundaClient();
// Node.js only: deploy directly from file paths
const result = await camunda.deployResourcesFromFiles([
"./process.bpmn",
"./decision.dmn",
]);
console.log(`Deployment key: ${result.deploymentKey}`);
}
Operation Id
createDeployment
Tags
Resource
createDocument()
createDocument(input, options?): CancelablePromise<DocumentReference>;
Upload document
Upload a document to the Camunda 8 cluster.
Note that this is currently supported for document stores of type: AWS, GCP, in-memory (non-production), local (non-production)
Parameters
input
options?
Returns
CancelablePromise<DocumentReference>
Example
async function createDocumentExample() {
const camunda = createCamundaClient();
const file = new Blob(["Hello, world!"], { type: "text/plain" });
const result = await camunda.createDocument({
file,
metadata: { fileName: "hello.txt" },
});
console.log(`Document ID: ${result.documentId}`);
}
Operation Id
createDocument
Tags
Document
createDocumentLink()
createDocumentLink(input, options?): CancelablePromise<DocumentLink>;
Create document link
Create a link to a document in the Camunda 8 cluster.
Note that this is currently supported for document stores of type: AWS, GCP
Parameters
input
options?
Returns
CancelablePromise<DocumentLink>
Example
async function createDocumentLinkExample(documentId: DocumentId) {
const camunda = createCamundaClient();
const link = await camunda.createDocumentLink({
documentId,
timeToLive: 3600000,
});
console.log(`Document link: ${link.url}`);
}
Operation Id
createDocumentLink
Tags
Document
createDocuments()
createDocuments(input, options?): CancelablePromise<DocumentCreationBatchResponse>;
Upload multiple documents
Upload multiple documents to the Camunda 8 cluster.
The caller must provide a file name for each document, which will be used in case of a multi-status response
to identify which documents failed to upload. The file name can be provided in the Content-Disposition header
of the file part or in the fileName field of the metadata. You can add a parallel array of metadata objects. These
are matched with the files based on index, and must have the same length as the files array.
To pass homogenous metadata for all files, spread the metadata over the metadata array.
A filename value provided explicitly via the metadata array in the request overrides the Content-Disposition header
of the file part.
In case of a multi-status response, the response body will contain a list of DocumentBatchProblemDetail objects,
each of which contains the file name of the document that failed to upload and the reason for the failure.
The client can choose to retry the whole batch or individual documents based on the response.
Note that this is currently supported for document stores of type: AWS, GCP, in-memory (non-production), local (non-production)
Parameters
input
options?
Returns
CancelablePromise<DocumentCreationBatchResponse>
Example
async function createDocumentsExample() {
const camunda = createCamundaClient();
const file1 = new Blob(["File one"], { type: "text/plain" });
const file2 = new Blob(["File two"], { type: "text/plain" });
const result = await camunda.createDocuments({
files: [file1, file2],
metadataList: [{ fileName: "one.txt" }, { fileName: "two.txt" }],
});
for (const doc of result.createdDocuments ?? []) {
console.log(`Created: ${doc.documentId}`);
}
}
Operation Id
createDocuments
Tags
Document
createElementInstanceVariables()
createElementInstanceVariables(input, options?): CancelablePromise<void>;
Update element instance variables
Updates all the variables of a particular scope (for example, process instance, element instance) with the given variable data.
Specify the element instance in the elementInstanceKey parameter.
Variable updates can be delayed by listener-related processing; if processing exceeds the
request timeout, this endpoint can return 504. Other gateway timeout causes are also
possible. Retry with backoff and inspect listener worker availability and logs when this
repeats.
Parameters
input
createElementInstanceVariablesInput
options?
Returns
CancelablePromise<void>
Example
async function createElementInstanceVariablesExample(
elementInstanceKey: ElementInstanceKey
) {
const camunda = createCamundaClient();
await camunda.createElementInstanceVariables({
elementInstanceKey,
variables: { orderId: "ORD-12345", status: "processing" },
});
}
Operation Id
createElementInstanceVariables
Tags
Element instance
createGlobalClusterVariable()
createGlobalClusterVariable(input, options?): CancelablePromise<ClusterVariableResult>;
Create a global-scoped cluster variable
Create a global-scoped cluster variable.
Parameters
input
options?
Returns
CancelablePromise<ClusterVariableResult>
Example
async function createGlobalClusterVariableExample() {
const camunda = createCamundaClient();
const result = await camunda.createGlobalClusterVariable({
name: "feature-flags",
value: { darkMode: true },
});
console.log(`Created: ${result.name}`);
}
Operation Id
createGlobalClusterVariable
Tags
Cluster Variable
createGlobalTaskListener()
createGlobalTaskListener(input, options?): CancelablePromise<GlobalTaskListenerResult>;
Create global user task listener
Create a new global user task listener.
Parameters
input
CreateGlobalTaskListenerRequest
options?
Returns
CancelablePromise<GlobalTaskListenerResult>
Example
async function createGlobalTaskListenerExample(id: GlobalListenerId) {
const camunda = createCamundaClient();
const result = await camunda.createGlobalTaskListener({
id,
eventTypes: ["completing"],
type: "audit-log-listener",
});
console.log(`Created listener: ${result.id}`);
}
Operation Id
createGlobalTaskListener
Tags
Global listener
createGroup()
createGroup(input, options?): CancelablePromise<GroupCreateResult>;
Create group
Create a new group.
Parameters
input
options?
Returns
CancelablePromise<GroupCreateResult>
Example
async function createGroupExample() {
const camunda = createCamundaClient();
const result = await camunda.createGroup({
groupId: "engineering-team",
name: "Engineering Team",
});
console.log(`Created group: ${result.groupId}`);
}
Operation Id
createGroup
Tags
Group
createJobWorker()
createJobWorker<In, Out, Headers>(cfg): JobWorker;
Create a job worker that activates and processes jobs of the given type.
Worker configuration fields inherit global defaults resolved via the
unified configuration (environment variables or equivalent CAMUNDA_WORKER_*
keys provided via CamundaOptions.config) when not explicitly set on the
config object.
Type Parameters
In
In extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Out
Out extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Headers
Headers extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Parameters
cfg
JobWorkerConfig<In, Out, Headers>
Worker configuration
Returns
Examples
async function createJobWorkerExample() {
const camunda = createCamundaClient();
const _worker = camunda.createJobWorker({
jobType: "payment-processing",
jobTimeoutMs: 30000,
maxParallelJobs: 5,
jobHandler: async (job): Promise<JobActionReceipt> => {
console.log(`Processing job ${job.jobKey}`);
return job.complete({ processed: true });
},
});
// Workers run continuously until closed
// worker.close();
}
async function jobWorkerWithErrorHandlingExample() {
const camunda = createCamundaClient();
const worker = camunda.createJobWorker({
jobType: "email-sending",
jobTimeoutMs: 60000,
maxParallelJobs: 10,
pollIntervalMs: 300,
jobHandler: async (job): Promise<JobActionReceipt> => {
try {
console.log(`Sending email for job ${job.jobKey}`);
return job.complete({ sent: true });
} catch (err) {
return job.fail({
errorMessage: String(err),
retries: (job.retries ?? 1) - 1,
});
}
},
});
void worker;
}
createMappingRule()
createMappingRule(input, options?): CancelablePromise<MappingRuleCreateUpdateResult>;
Create mapping rule
Create a new mapping rule
Parameters
input
options?
Returns
CancelablePromise<MappingRuleCreateUpdateResult>
Example
async function createMappingRuleExample() {
const camunda = createCamundaClient();
const result = await camunda.createMappingRule({
mappingRuleId: "ldap-group-mapping",
name: "LDAP Group Mapping",
claimName: "groups",
claimValue: "engineering",
});
console.log(`Created mapping rule: ${result.mappingRuleId}`);
}
Operation Id
createMappingRule
Tags
Mapping rule
createProcessInstance()
createProcessInstance(input, options?): CancelablePromise<CreateProcessInstanceResult>;
Create process instance
Creates and starts an instance of the specified process. The process definition to use to create the instance can be specified either using its unique key (as returned by Deploy resources), or using the BPMN process id and a version.
Waits for the completion of the process instance before returning a result when awaitCompletion is enabled.
Parameters
input
| ProcessInstanceCreationInstructionByKey
| ProcessInstanceCreationInstructionById
options?
Returns
CancelablePromise<CreateProcessInstanceResult>
Examples
async function createProcessInstanceByIdExample(
processDefinitionId: ProcessDefinitionId
) {
const camunda = createCamundaClient();
const result = await camunda.createProcessInstance({
processDefinitionId,
variables: {
orderId: "ORD-12345",
amount: 99.95,
},
});
console.log(`Started process instance: ${result.processInstanceKey}`);
}
async function createProcessInstanceByKeyExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
// Key from a previous API response (e.g. deployment)
const result = await camunda.createProcessInstance({
processDefinitionKey,
variables: {
orderId: "ORD-12345",
amount: 99.95,
},
});
console.log(`Started process instance: ${result.processInstanceKey}`);
}
Operation Id
createProcessInstance
Tags
Process instance
createRole()
createRole(input, options?): CancelablePromise<RoleCreateResult>;
Create role
Create a new role.
Parameters
input
options?
Returns
CancelablePromise<RoleCreateResult>
Example
async function createRoleExample() {
const camunda = createCamundaClient();
const result = await camunda.createRole({
roleId: "process-admin",
name: "Process Admin",
});
console.log(`Created role: ${result.roleId}`);
}
Operation Id
createRole
Tags
Role
createTenant()
createTenant(input, options?): CancelablePromise<TenantCreateResult>;
Create tenant
Creates a new tenant.
Parameters
input
options?
Returns
CancelablePromise<TenantCreateResult>
Example
async function createTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const result = await camunda.createTenant({
tenantId,
name: "Customer Service",
});
console.log(`Created tenant: ${result.tenantId}`);
}
Operation Id
createTenant
Tags
Tenant
createTenantClusterVariable()
createTenantClusterVariable(input, options?): CancelablePromise<ClusterVariableResult>;
Create a tenant-scoped cluster variable
Create a new cluster variable for the given tenant.
Parameters
input
createTenantClusterVariableInput
options?
Returns
CancelablePromise<ClusterVariableResult>
Example
async function createTenantClusterVariableExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const result = await camunda.createTenantClusterVariable({
tenantId,
name: "config",
value: { region: "us-east-1" },
});
console.log(`Created: ${result.name}`);
}
Operation Id
createTenantClusterVariable
Tags
Cluster Variable
createThreadedJobWorker()
createThreadedJobWorker<In, Out, Headers>(cfg): ThreadedJobWorker;
Create a threaded job worker that runs handler logic in a pool of worker threads.
The handler must be a separate module file that exports a default function with
signature (job, client) => Promise<JobActionReceipt>.
This keeps the main event loop free for polling and I/O, dramatically improving throughput for CPU-bound job handlers.
Worker configuration fields inherit global defaults resolved via the
unified configuration (environment variables or equivalent CAMUNDA_WORKER_*
keys provided via CamundaOptions.config) when not explicitly set on the
config object.
Type Parameters
In
In extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Out
Out extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Headers
Headers extends ZodType<unknown, unknown, $ZodTypeInternals<unknown, unknown>> = any
Parameters
cfg
ThreadedJobWorkerConfig<In, Out, Headers>
Threaded worker configuration
Returns
Example
const worker = client.createThreadedJobWorker({
jobType: "cpu-heavy-task",
handlerModule: "./my-handler.js",
maxParallelJobs: 32,
jobTimeoutMs: 30000,
});
createUser()
createUser(input, options?): CancelablePromise<UserCreateResult>;
Create user
Create a new user.
Parameters
input
options?
Returns
CancelablePromise<UserCreateResult>
Example
async function createUserExample(username: Username) {
const camunda = createCamundaClient();
const result = await camunda.createUser({
username,
name: "Alice Smith",
email: "alice@example.com",
password: "secure-password-123",
});
console.log(`Created user: ${result.username}`);
}
Operation Id
createUser
Tags
User
deleteAuthorization()
deleteAuthorization(input, options?): CancelablePromise<void>;
Delete authorization
Deletes the authorization with the given key.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteAuthorizationExample(authorizationKey: AuthorizationKey) {
const camunda = createCamundaClient();
await camunda.deleteAuthorization({ authorizationKey });
}
Operation Id
deleteAuthorization
Tags
Authorization
deleteDecisionInstance()
deleteDecisionInstance(input, options?): CancelablePromise<void>;
Delete decision instance
Delete all associated decision evaluations based on provided key.
Parameters
input
object & object
options?
Returns
CancelablePromise<void>
Example
async function deleteDecisionInstanceExample(
decisionEvaluationKey: DecisionEvaluationKey
) {
const camunda = createCamundaClient();
await camunda.deleteDecisionInstance({ decisionEvaluationKey });
}
Operation Id
deleteDecisionInstance
Tags
Decision instance
deleteDecisionInstancesBatchOperation()
deleteDecisionInstancesBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Delete decision instances (batch)
Delete multiple decision instances. This will delete the historic data from secondary storage. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
DecisionInstanceDeletionBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function deleteDecisionInstancesBatchOperationExample() {
const camunda = createCamundaClient();
const result = await camunda.deleteDecisionInstancesBatchOperation({
filter: {},
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
deleteDecisionInstancesBatchOperation
Tags
Decision instance
deleteDocument()
deleteDocument(input, options?): CancelablePromise<void>;
Delete document
Delete a document from the Camunda 8 cluster.
Note that this is currently supported for document stores of type: AWS, GCP, in-memory (non-production), local (non-production)
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteDocumentExample(documentId: DocumentId) {
const camunda = createCamundaClient();
await camunda.deleteDocument({ documentId });
}
Operation Id
deleteDocument
Tags
Document
deleteGlobalClusterVariable()
deleteGlobalClusterVariable(input, options?): CancelablePromise<void>;
Delete a global-scoped cluster variable
Delete a global-scoped cluster variable.
Parameters
input
deleteGlobalClusterVariableInput
options?
Returns
CancelablePromise<void>
Example
async function deleteGlobalClusterVariableExample() {
const camunda = createCamundaClient();
await camunda.deleteGlobalClusterVariable({ name: "feature-flags" });
}
Operation Id
deleteGlobalClusterVariable
Tags
Cluster Variable
deleteGlobalTaskListener()
deleteGlobalTaskListener(input, options?): CancelablePromise<void>;
Delete global user task listener
Deletes a global user task listener.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteGlobalTaskListenerExample(id: GlobalListenerId) {
const camunda = createCamundaClient();
await camunda.deleteGlobalTaskListener({
id,
});
}
Operation Id
deleteGlobalTaskListener
Tags
Global listener
deleteGroup()
deleteGroup(input, options?): CancelablePromise<void>;
Delete group
Deletes the group with the given ID.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteGroupExample() {
const camunda = createCamundaClient();
await camunda.deleteGroup({ groupId: "engineering-team" });
}
Operation Id
deleteGroup
Tags
Group
deleteMappingRule()
deleteMappingRule(input, options?): CancelablePromise<void>;
Delete a mapping rule
Deletes the mapping rule with the given ID.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteMappingRuleExample() {
const camunda = createCamundaClient();
await camunda.deleteMappingRule({ mappingRuleId: "ldap-group-mapping" });
}
Operation Id
deleteMappingRule
Tags
Mapping rule
deleteProcessInstance()
deleteProcessInstance(input, options?): CancelablePromise<void>;
Delete process instance
Deletes a process instance. Only instances that are completed or terminated can be deleted.
Parameters
input
object & object
options?
Returns
CancelablePromise<void>
Example
async function deleteProcessInstanceExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
await camunda.deleteProcessInstance({ processInstanceKey });
}
Operation Id
deleteProcessInstance
Tags
Process instance
deleteProcessInstancesBatchOperation()
deleteProcessInstancesBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Delete process instances (batch)
Delete multiple process instances. This will delete the historic data from secondary storage. Only process instances in a final state (COMPLETED or TERMINATED) can be deleted. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
ProcessInstanceDeletionBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function deleteProcessInstancesBatchOperationExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const result = await camunda.deleteProcessInstancesBatchOperation({
filter: {
processDefinitionKey,
},
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
deleteProcessInstancesBatchOperation
Tags
Process instance
deleteResource()
deleteResource(input, options?): CancelablePromise<DeleteResourceResponse>;
Delete resource
Deletes a deployed resource. This can be a process definition, decision requirements
definition, or form definition deployed using the deploy resources endpoint. Specify the
resource you want to delete in the resourceKey parameter.
Once a resource has been deleted it cannot be recovered. If the resource needs to be available again, a new deployment of the resource is required.
By default, only the resource itself is deleted from the runtime state. To also delete the
historic data associated with a resource, set the deleteHistory flag in the request body
to true. The historic data is deleted asynchronously via a batch operation. The details of
the created batch operation are included in the response. Note that history deletion is only
supported for process resources; for other resource types this flag is ignored and no history
will be deleted.
Parameters
input
object & object
options?
Returns
CancelablePromise<DeleteResourceResponse>
Example
async function deleteResourceExample(resourceKey: ProcessDefinitionKey) {
const camunda = createCamundaClient();
// Use a process definition key as a resource key for deletion
await camunda.deleteResource({
resourceKey,
});
}
Operation Id
deleteResource
Tags
Resource
deleteRole()
deleteRole(input, options?): CancelablePromise<void>;
Delete role
Deletes the role with the given ID.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteRoleExample() {
const camunda = createCamundaClient();
await camunda.deleteRole({ roleId: "process-admin" });
}
Operation Id
deleteRole
Tags
Role
deleteTenant()
deleteTenant(input, options?): CancelablePromise<void>;
Delete tenant
Deletes an existing tenant.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.deleteTenant({ tenantId });
}
Operation Id
deleteTenant
Tags
Tenant
deleteTenantClusterVariable()
deleteTenantClusterVariable(input, options?): CancelablePromise<void>;
Delete a tenant-scoped cluster variable
Delete a tenant-scoped cluster variable.
Parameters
input
deleteTenantClusterVariableInput
options?
Returns
CancelablePromise<void>
Example
async function deleteTenantClusterVariableExample(tenantId: TenantId) {
const camunda = createCamundaClient();
await camunda.deleteTenantClusterVariable({
tenantId,
name: "config",
});
}
Operation Id
deleteTenantClusterVariable
Tags
Cluster Variable
deleteUser()
deleteUser(input, options?): CancelablePromise<void>;
Delete user
Deletes a user.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function deleteUserExample(username: Username) {
const camunda = createCamundaClient();
await camunda.deleteUser({ username });
}
Operation Id
deleteUser
Tags
User
deployResourcesFromFiles()
deployResourcesFromFiles(resourceFilenames, options?): CancelablePromise<ExtendedDeploymentResult>;
Node-only convenience: deploy resources from local filesystem paths.
Parameters
resourceFilenames
string[]
Absolute or relative file paths to BPMN/DMN/form/resource files.
options?
Optional: tenantId.
tenantId?
string
Returns
CancelablePromise<ExtendedDeploymentResult>
ExtendedDeploymentResult
emitSupportLogPreamble()
emitSupportLogPreamble(): void;
Emit the standard support log preamble & redacted configuration to the current support logger. Safe to call multiple times; subsequent calls are ignored (idempotent). Useful when a custom supportLogger was injected and you still want the canonical header & config dump.
Returns
void
evaluateConditionals()
evaluateConditionals(input, options?): CancelablePromise<EvaluateConditionalResult>;
Evaluate root level conditional start events
Evaluates root-level conditional start events for process definitions. If the evaluation is successful, it will return the keys of all created process instances, along with their associated process definition key. Multiple root-level conditional start events of the same process definition can trigger if their conditions evaluate to true.
Parameters
input
ConditionalEvaluationInstruction
options?
Returns
CancelablePromise<EvaluateConditionalResult>
Example
async function evaluateConditionalsExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const result = await camunda.evaluateConditionals({
variables: { orderReady: true },
tenantId,
});
console.log(`Evaluated conditionals: ${JSON.stringify(result)}`);
}
Operation Id
evaluateConditionals
Tags
Conditional
evaluateDecision()
evaluateDecision(input, options?): CancelablePromise<EvaluateDecisionResult>;
Evaluate decision
Evaluates a decision. You specify the decision to evaluate either by using its unique key (as returned by DeployResource), or using the decision ID. When using the decision ID, the latest deployed version of the decision is used.
Parameters
input
| DecisionEvaluationById
| DecisionEvaluationByKey
options?
Returns
CancelablePromise<EvaluateDecisionResult>
Examples
async function evaluateDecisionByIdExample(
decisionDefinitionId: DecisionDefinitionId
) {
const camunda = createCamundaClient();
const result = await camunda.evaluateDecision({
decisionDefinitionId,
variables: {
amount: 1000,
invoiceCategory: "Misc",
},
});
console.log(`Decision: ${result.decisionDefinitionId}`);
console.log(`Output: ${result.output}`);
}
async function evaluateDecisionByKeyExample(
decisionDefinitionKey: DecisionDefinitionKey
) {
const camunda = createCamundaClient();
const result = await camunda.evaluateDecision({
decisionDefinitionKey,
variables: {
amount: 1000,
invoiceCategory: "Misc",
},
});
console.log(`Decision output: ${result.output}`);
}
Operation Id
evaluateDecision
Tags
Decision definition
evaluateExpression()
evaluateExpression(input, options?): CancelablePromise<ExpressionEvaluationResult>;
Evaluate an expression
Evaluates a FEEL expression and returns the result. Supports references to tenant scoped cluster variables when a tenant ID is provided.
Parameters
input
options?
Returns
CancelablePromise<ExpressionEvaluationResult>
Example
async function evaluateExpressionExample() {
const camunda = createCamundaClient();
const result = await camunda.evaluateExpression({
expression: "= x + y",
variables: { x: 10, y: 20 },
});
console.log(`Result: ${result.result}`);
}
Operation Id
evaluateExpression
Tags
Expression
failJob()
failJob(input, options?): CancelablePromise<void>;
Fail job
Mark the job as failed.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function failJobExample(jobKey: JobKey) {
const camunda = createCamundaClient();
await camunda.failJob({
jobKey,
retries: 2,
errorMessage: "Payment gateway timeout",
retryBackOff: 5000,
});
}
Operation Id
failJob
Tags
Job
forceAuthRefresh()
forceAuthRefresh(): Promise<string | undefined>;
Returns
Promise<string | undefined>
getAuditLog()
getAuditLog(
input,
consistencyManagement,
options?): CancelablePromise<AuditLogResult>;
Get audit log
Get an audit log entry by auditLogKey.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<AuditLogResult>
Example
async function getAuditLogExample(auditLogKey: AuditLogKey) {
const camunda = createCamundaClient();
const log = await camunda.getAuditLog(
{ auditLogKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Audit log: ${log.operationType}`);
}
Operation Id
getAuditLog
Tags
Audit Log
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getAuthentication()
getAuthentication(options?): CancelablePromise<CamundaUserResult>;
Get current user
Retrieves the current authenticated user.
Parameters
options?
Returns
CancelablePromise<CamundaUserResult>
Example
async function getAuthenticationExample() {
const camunda = createCamundaClient();
const user = await camunda.getAuthentication();
console.log(`Authenticated as: ${user.username}`);
}
Operation Id
getAuthentication
Tags
Authentication
getAuthHeaders()
getAuthHeaders(): Promise<Record<string, string>>;
Returns
Promise<Record<string, string>>
getAuthorization()
getAuthorization(
input,
consistencyManagement,
options?): CancelablePromise<AuthorizationResult>;
Get authorization
Get authorization by the given key.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<AuthorizationResult>
Example
async function getAuthorizationExample(authorizationKey: AuthorizationKey) {
const camunda = createCamundaClient();
const authorization = await camunda.getAuthorization(
{ authorizationKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Owner: ${authorization.ownerId} (${authorization.ownerType})`);
}
Operation Id
getAuthorization
Tags
Authorization
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getBackpressureState()
getBackpressureState():
| {
backoffMs: number;
consecutive: number;
permitsCurrent: number;
permitsMax: number | null;
severity: BackpressureSeverity;
waiters: number;
}
| {
consecutive: number;
permitsCurrent: number;
permitsMax: null;
severity: string;
waiters: number;
};
Public accessor for current backpressure adaptive limiter state (stable)
Returns
| {
backoffMs: number;
consecutive: number;
permitsCurrent: number;
permitsMax: number | null;
severity: BackpressureSeverity;
waiters: number;
}
| {
consecutive: number;
permitsCurrent: number;
permitsMax: null;
severity: string;
waiters: number;
}
getBatchOperation()
getBatchOperation(
input,
consistencyManagement,
options?): CancelablePromise<BatchOperationResponse>;
Get batch operation
Get batch operation by key.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<BatchOperationResponse>
Example
async function getBatchOperationExample(batchOperationKey: BatchOperationKey) {
const camunda = createCamundaClient();
const batch = await camunda.getBatchOperation(
{ batchOperationKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Batch: ${batch.batchOperationType} (${batch.state})`);
}
Operation Id
getBatchOperation
Tags
Batch operation
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getConfig()
getConfig(): Readonly<CamundaConfig>;
Read-only snapshot of current hydrated configuration (do not mutate directly). Use configure(...) to apply changes.
Returns
Readonly<CamundaConfig>
getDecisionDefinition()
getDecisionDefinition(
input,
consistencyManagement,
options?): CancelablePromise<DecisionDefinitionResult>;
Get decision definition
Returns a decision definition by key.
Parameters
input
consistencyManagement
getDecisionDefinitionConsistency
options?
Returns
CancelablePromise<DecisionDefinitionResult>
Example
async function getDecisionDefinitionExample(
decisionDefinitionKey: DecisionDefinitionKey
) {
const camunda = createCamundaClient();
const definition = await camunda.getDecisionDefinition(
{ decisionDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Decision: ${definition.decisionDefinitionId}`);
console.log(`Version: ${definition.version}`);
}
Operation Id
getDecisionDefinition
Tags
Decision definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getDecisionDefinitionXml()
getDecisionDefinitionXml(
input,
consistencyManagement,
options?): CancelablePromise<string>;
Get decision definition XML
Returns decision definition as XML.
Parameters
input
consistencyManagement
getDecisionDefinitionXmlConsistency
options?
Returns
CancelablePromise<string>
Example
async function getDecisionDefinitionXmlExample(
decisionDefinitionKey: DecisionDefinitionKey
) {
const camunda = createCamundaClient();
const xml = await camunda.getDecisionDefinitionXml(
{ decisionDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`XML length: ${JSON.stringify(xml).length}`);
}
Operation Id
getDecisionDefinitionXML
Tags
Decision definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getDecisionInstance()
getDecisionInstance(
input,
consistencyManagement,
options?): CancelablePromise<DecisionInstanceGetQueryResult>;
Get decision instance
Returns a decision instance.
Parameters
input
consistencyManagement
getDecisionInstanceConsistency
options?
Returns
CancelablePromise<DecisionInstanceGetQueryResult>
Example
async function getDecisionInstanceExample(
decisionEvaluationInstanceKey: DecisionEvaluationInstanceKey
) {
const camunda = createCamundaClient();
const instance = await camunda.getDecisionInstance(
{ decisionEvaluationInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Decision: ${instance.decisionDefinitionId}`);
}
Operation Id
getDecisionInstance
Tags
Decision instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getDecisionRequirements()
getDecisionRequirements(
input,
consistencyManagement,
options?): CancelablePromise<DecisionRequirementsResult>;
Get decision requirements
Returns Decision Requirements as JSON.
Parameters
input
consistencyManagement
getDecisionRequirementsConsistency
options?
Returns
CancelablePromise<DecisionRequirementsResult>
Example
async function getDecisionRequirementsExample(
decisionRequirementsKey: DecisionRequirementsKey
) {
const camunda = createCamundaClient();
const requirements = await camunda.getDecisionRequirements(
{ decisionRequirementsKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Requirements: ${requirements.decisionRequirementsId}`);
}
Operation Id
getDecisionRequirements
Tags
Decision requirements
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getDecisionRequirementsXml()
getDecisionRequirementsXml(
input,
consistencyManagement,
options?): CancelablePromise<string>;
Get decision requirements XML
Returns decision requirements as XML.
Parameters
input
getDecisionRequirementsXmlInput
consistencyManagement
getDecisionRequirementsXmlConsistency
options?
Returns
CancelablePromise<string>
Example
async function getDecisionRequirementsXmlExample(
decisionRequirementsKey: DecisionRequirementsKey
) {
const camunda = createCamundaClient();
const xml = await camunda.getDecisionRequirementsXml(
{ decisionRequirementsKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`XML length: ${JSON.stringify(xml).length}`);
}
Operation Id
getDecisionRequirementsXML
Tags
Decision requirements
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getDocument()
getDocument(input, options?): CancelablePromise<Blob>;
Download document
Download a document from the Camunda 8 cluster.
Note that this is currently supported for document stores of type: AWS, GCP, in-memory (non-production), local (non-production)
Parameters
input
options?
Returns
CancelablePromise<Blob>
Example
async function getDocumentExample(documentId: DocumentId) {
const camunda = createCamundaClient();
await camunda.getDocument({ documentId });
console.log(`Downloaded document: ${documentId}`);
}
Operation Id
getDocument
Tags
Document
getElementInstance()
getElementInstance(
input,
consistencyManagement,
options?): CancelablePromise<ElementInstanceResult>;
Get element instance
Returns element instance as JSON.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<ElementInstanceResult>
Example
async function getElementInstanceExample(
elementInstanceKey: ElementInstanceKey
) {
const camunda = createCamundaClient();
const element = await camunda.getElementInstance(
{ elementInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Element: ${element.elementId} (${element.type})`);
}
Operation Id
getElementInstance
Tags
Element instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getErrorMode()
getErrorMode(): "throw" | "result";
Internal accessor (read-only) for eventual consistency error mode.
Returns
"throw" | "result"
getGlobalClusterVariable()
getGlobalClusterVariable(
input,
consistencyManagement,
options?): CancelablePromise<ClusterVariableResult>;
Get a global-scoped cluster variable
Get a global-scoped cluster variable.
Parameters
input
consistencyManagement
getGlobalClusterVariableConsistency
options?
Returns
CancelablePromise<ClusterVariableResult>
Example
async function getGlobalClusterVariableExample() {
const camunda = createCamundaClient();
const variable = await camunda.getGlobalClusterVariable(
{ name: "feature-flags" },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`${variable.name} = ${variable.value}`);
}
Operation Id
getGlobalClusterVariable
Tags
Cluster Variable
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getGlobalJobStatistics()
getGlobalJobStatistics(
input,
consistencyManagement,
options?): CancelablePromise<GlobalJobStatisticsQueryResult>;
Global job statistics
Returns global aggregated counts for jobs. Filter by the creation time window (required) and optionally by jobType.
Parameters
input
consistencyManagement
getGlobalJobStatisticsConsistency
options?
Returns
CancelablePromise<GlobalJobStatisticsQueryResult>
Example
async function getGlobalJobStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getGlobalJobStatistics(
{
from: "2025-01-01T00:00:00Z",
to: "2025-12-31T23:59:59Z",
},
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Statistics retrieved: ${JSON.stringify(result)}`);
}
Operation Id
getGlobalJobStatistics
Tags
Job
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getGlobalTaskListener()
getGlobalTaskListener(
input,
consistencyManagement,
options?): CancelablePromise<GlobalTaskListenerResult>;
Get global user task listener
Get a global user task listener by its id.
Parameters
input
consistencyManagement
getGlobalTaskListenerConsistency
options?
Returns
CancelablePromise<GlobalTaskListenerResult>
Example
async function getGlobalTaskListenerExample(id: GlobalListenerId) {
const camunda = createCamundaClient();
const listener = await camunda.getGlobalTaskListener(
{ id },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Listener: ${listener.type} (${listener.eventTypes})`);
}
Operation Id
getGlobalTaskListener
Tags
Global listener
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getGroup()
getGroup(
input,
consistencyManagement,
options?): CancelablePromise<GroupResult>;
Get group
Get a group by its ID.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<GroupResult>
Example
async function getGroupExample() {
const camunda = createCamundaClient();
const group = await camunda.getGroup(
{ groupId: "engineering-team" },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Group: ${group.name}`);
}
Operation Id
getGroup
Tags
Group
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getIncident()
getIncident(
input,
consistencyManagement,
options?): CancelablePromise<IncidentResult>;
Get incident
Returns incident as JSON.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<IncidentResult>
Example
async function getIncidentExample(incidentKey: IncidentKey) {
const camunda = createCamundaClient();
const incident = await camunda.getIncident(
{ incidentKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Type: ${incident.errorType}`);
console.log(`State: ${incident.state}`);
console.log(`Message: ${incident.errorMessage}`);
}
Operation Id
getIncident
Tags
Incident
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getJobErrorStatistics()
getJobErrorStatistics(
input,
consistencyManagement,
options?): CancelablePromise<JobErrorStatisticsQueryResult>;
Get error metrics for a job type
Returns aggregated metrics per error for the given jobType.
Parameters
input
consistencyManagement
getJobErrorStatisticsConsistency
options?
Returns
CancelablePromise<JobErrorStatisticsQueryResult>
Example
async function getJobErrorStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getJobErrorStatistics(
{
filter: {
from: "2025-01-01T00:00:00Z",
to: "2025-12-31T23:59:59Z",
jobType: "payment-processing",
},
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(`Error: ${stat.errorMessage}, workers: ${stat.workers}`);
}
}
Operation Id
getJobErrorStatistics
Tags
Job
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getJobTimeSeriesStatistics()
getJobTimeSeriesStatistics(
input,
consistencyManagement,
options?): CancelablePromise<JobTimeSeriesStatisticsQueryResult>;
Get time-series metrics for a job type
Returns a list of time-bucketed metrics ordered ascending by time.
The from and to fields select the time window of interest.
Each item in the response corresponds to one time bucket of the requested resolution.
Parameters
input
consistencyManagement
getJobTimeSeriesStatisticsConsistency
options?
Returns
CancelablePromise<JobTimeSeriesStatisticsQueryResult>
Example
async function getJobTimeSeriesStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getJobTimeSeriesStatistics(
{
filter: {
from: "2025-01-01T00:00:00Z",
to: "2025-12-31T23:59:59Z",
jobType: "payment-processing",
},
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const point of result.items ?? []) {
console.log(`Time: ${point.time}, created: ${point.created.count}`);
}
}
Operation Id
getJobTimeSeriesStatistics
Tags
Job
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getJobTypeStatistics()
getJobTypeStatistics(
input,
consistencyManagement,
options?): CancelablePromise<JobTypeStatisticsQueryResult>;
Get job statistics by type
Get statistics about jobs, grouped by job type.
Parameters
input
consistencyManagement
getJobTypeStatisticsConsistency
options?
Returns
CancelablePromise<JobTypeStatisticsQueryResult>
Example
async function getJobTypeStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getJobTypeStatistics(
{},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(`Type: ${stat.jobType}, workers: ${stat.workers}`);
}
}
Operation Id
getJobTypeStatistics
Tags
Job
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getJobWorkerStatistics()
getJobWorkerStatistics(
input,
consistencyManagement,
options?): CancelablePromise<JobWorkerStatisticsQueryResult>;
Get job statistics by worker
Get statistics about jobs, grouped by worker, for a given job type.
Parameters
input
consistencyManagement
getJobWorkerStatisticsConsistency
options?
Returns
CancelablePromise<JobWorkerStatisticsQueryResult>
Example
async function getJobWorkerStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getJobWorkerStatistics(
{
filter: {
from: "2025-01-01T00:00:00Z",
to: "2025-12-31T23:59:59Z",
jobType: "payment-processing",
},
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(`Worker: ${stat.worker}, completed: ${stat.completed.count}`);
}
}
Operation Id
getJobWorkerStatistics
Tags
Job
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getLicense()
getLicense(options?): CancelablePromise<LicenseResponse>;
Get license status
Obtains the status of the current Camunda license.
Parameters
options?
Returns
CancelablePromise<LicenseResponse>
Example
async function getLicenseExample() {
const camunda = createCamundaClient();
const license = await camunda.getLicense();
console.log(`License type: ${license.validLicense}`);
}
Operation Id
getLicense
Tags
License
getMappingRule()
getMappingRule(
input,
consistencyManagement,
options?): CancelablePromise<MappingRuleResult>;
Get a mapping rule
Gets the mapping rule with the given ID.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<MappingRuleResult>
Example
async function getMappingRuleExample() {
const camunda = createCamundaClient();
const rule = await camunda.getMappingRule(
{ mappingRuleId: "ldap-group-mapping" },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Rule: ${rule.name} (${rule.claimName}=${rule.claimValue})`);
}
Operation Id
getMappingRule
Tags
Mapping rule
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinition()
getProcessDefinition(
input,
consistencyManagement,
options?): CancelablePromise<ProcessDefinitionResult>;
Get process definition
Returns process definition as JSON.
Parameters
input
consistencyManagement
getProcessDefinitionConsistency
options?
Returns
CancelablePromise<ProcessDefinitionResult>
Example
async function getProcessDefinitionExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const definition = await camunda.getProcessDefinition(
{ processDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(
`Process: ${definition.processDefinitionId} v${definition.version}`
);
}
Operation Id
getProcessDefinition
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinitionInstanceStatistics()
getProcessDefinitionInstanceStatistics(
input,
consistencyManagement,
options?): CancelablePromise<ProcessDefinitionInstanceStatisticsQueryResult>;
Get process instance statistics
Get statistics about process instances, grouped by process definition and tenant.
Parameters
input
ProcessDefinitionInstanceStatisticsQuery
consistencyManagement
getProcessDefinitionInstanceStatisticsConsistency
options?
Returns
CancelablePromise<ProcessDefinitionInstanceStatisticsQueryResult>
Example
async function getProcessDefinitionInstanceStatisticsExample() {
const camunda = createCamundaClient();
const result = await camunda.getProcessDefinitionInstanceStatistics(
{},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(
`Definition ${stat.processDefinitionId}: ${stat.activeInstancesWithoutIncidentCount} active`
);
}
}
Operation Id
getProcessDefinitionInstanceStatistics
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinitionInstanceVersionStatistics()
getProcessDefinitionInstanceVersionStatistics(
input,
consistencyManagement,
options?): CancelablePromise<ProcessDefinitionInstanceVersionStatisticsQueryResult>;
Get process instance statistics by version
Get statistics about process instances, grouped by version for a given process definition. The process definition ID must be provided as a required field in the request body filter.
Parameters
input
ProcessDefinitionInstanceVersionStatisticsQuery
consistencyManagement
getProcessDefinitionInstanceVersionStatisticsConsistency
options?
Returns
CancelablePromise<ProcessDefinitionInstanceVersionStatisticsQueryResult>
Example
async function getProcessDefinitionInstanceVersionStatisticsExample(
processDefinitionId: ProcessDefinitionId
) {
const camunda = createCamundaClient();
const result = await camunda.getProcessDefinitionInstanceVersionStatistics(
{
filter: {
processDefinitionId,
},
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(
`Version ${stat.processDefinitionVersion}: ${stat.activeInstancesWithoutIncidentCount} active`
);
}
}
Operation Id
getProcessDefinitionInstanceVersionStatistics
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinitionMessageSubscriptionStatistics()
getProcessDefinitionMessageSubscriptionStatistics(
input,
consistencyManagement,
options?): CancelablePromise<ProcessDefinitionMessageSubscriptionStatisticsQueryResult>;
Get message subscription statistics
Get message subscription statistics, grouped by process definition.
Parameters
input
ProcessDefinitionMessageSubscriptionStatisticsQuery
consistencyManagement
getProcessDefinitionMessageSubscriptionStatisticsConsistency
options?
Returns
CancelablePromise<ProcessDefinitionMessageSubscriptionStatisticsQueryResult>
Example
async function getProcessDefinitionMessageSubscriptionStatisticsExample() {
const camunda = createCamundaClient();
const result =
await camunda.getProcessDefinitionMessageSubscriptionStatistics(
{},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(
`Definition ${stat.processDefinitionId}: ${stat.activeSubscriptions} subscriptions`
);
}
}
Operation Id
getProcessDefinitionMessageSubscriptionStatistics
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinitionStatistics()
getProcessDefinitionStatistics(
input,
consistencyManagement,
options?): CancelablePromise<ProcessDefinitionElementStatisticsQueryResult>;
Get process definition statistics
Get statistics about elements in currently running process instances by process definition key and search filter.
Parameters
input
getProcessDefinitionStatisticsInput
consistencyManagement
getProcessDefinitionStatisticsConsistency
options?
Returns
CancelablePromise<ProcessDefinitionElementStatisticsQueryResult>
Example
async function getProcessDefinitionStatisticsExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const result = await camunda.getProcessDefinitionStatistics(
{ processDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(`Element ${stat.elementId}: active=${stat.active}`);
}
}
Operation Id
getProcessDefinitionStatistics
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessDefinitionXml()
getProcessDefinitionXml(
input,
consistencyManagement,
options?): CancelablePromise<string>;
Get process definition XML
Returns process definition as XML.
Parameters
input
consistencyManagement
getProcessDefinitionXmlConsistency
options?
Returns
CancelablePromise<string>
Example
async function getProcessDefinitionXmlExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const xml = await camunda.getProcessDefinitionXml(
{ processDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`XML length: ${JSON.stringify(xml).length}`);
}
Operation Id
getProcessDefinitionXML
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstance()
getProcessInstance(
input,
consistencyManagement,
options?): CancelablePromise<ProcessInstanceResult>;
Get process instance
Get the process instance by the process instance key.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<ProcessInstanceResult>
Example
async function getProcessInstanceExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
const instance = await camunda.getProcessInstance(
{ processInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`State: ${instance.state}`);
console.log(`Process: ${instance.processDefinitionId}`);
}
Operation Id
getProcessInstance
Tags
Process instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstanceCallHierarchy()
getProcessInstanceCallHierarchy(
input,
consistencyManagement,
options?): CancelablePromise<ProcessInstanceCallHierarchyEntry[]>;
Get call hierarchy
Returns the call hierarchy for a given process instance, showing its ancestry up to the root instance.
Parameters
input
getProcessInstanceCallHierarchyInput
consistencyManagement
getProcessInstanceCallHierarchyConsistency
options?
Returns
CancelablePromise<ProcessInstanceCallHierarchyEntry[]>
Example
async function getProcessInstanceCallHierarchyExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
const result = await camunda.getProcessInstanceCallHierarchy(
{ processInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Call hierarchy entries: ${result.length}`);
}
Operation Id
getProcessInstanceCallHierarchy
Tags
Process instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstanceSequenceFlows()
getProcessInstanceSequenceFlows(
input,
consistencyManagement,
options?): CancelablePromise<ProcessInstanceSequenceFlowsQueryResult>;
Get sequence flows
Get sequence flows taken by the process instance.
Parameters
input
getProcessInstanceSequenceFlowsInput
consistencyManagement
getProcessInstanceSequenceFlowsConsistency
options?
Returns
CancelablePromise<ProcessInstanceSequenceFlowsQueryResult>
Example
async function getProcessInstanceSequenceFlowsExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
const result = await camunda.getProcessInstanceSequenceFlows(
{ processInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
for (const flow of result.items ?? []) {
console.log(`Sequence flow: ${flow.sequenceFlowId}`);
}
}
Operation Id
getProcessInstanceSequenceFlows
Tags
Process instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstanceStatistics()
getProcessInstanceStatistics(
input,
consistencyManagement,
options?): CancelablePromise<ProcessInstanceElementStatisticsQueryResult>;
Get element instance statistics
Get statistics about elements by the process instance key.
Parameters
input
getProcessInstanceStatisticsInput
consistencyManagement
getProcessInstanceStatisticsConsistency
options?
Returns
CancelablePromise<ProcessInstanceElementStatisticsQueryResult>
Example
async function getProcessInstanceStatisticsExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
const result = await camunda.getProcessInstanceStatistics(
{ processInstanceKey },
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(`Element ${stat.elementId}: active=${stat.active}`);
}
}
Operation Id
getProcessInstanceStatistics
Tags
Process instance
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstanceStatisticsByDefinition()
getProcessInstanceStatisticsByDefinition(
input,
consistencyManagement,
options?): CancelablePromise<IncidentProcessInstanceStatisticsByDefinitionQueryResult>;
Get process instance statistics by definition
Returns statistics for active process instances with incidents, grouped by process definition. The result set is scoped to a specific incident error hash code, which must be provided as a filter in the request body.
Parameters
input
IncidentProcessInstanceStatisticsByDefinitionQuery
consistencyManagement
getProcessInstanceStatisticsByDefinitionConsistency
options?
Returns
CancelablePromise<IncidentProcessInstanceStatisticsByDefinitionQueryResult>
Example
async function getProcessInstanceStatisticsByDefinitionExample() {
const camunda = createCamundaClient();
const result = await camunda.getProcessInstanceStatisticsByDefinition(
{
filter: {
errorHashCode: 12345,
},
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(
`Definition ${stat.processDefinitionId}: ${stat.activeInstancesWithErrorCount} incidents`
);
}
}
Operation Id
getProcessInstanceStatisticsByDefinition
Tags
Incident
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getProcessInstanceStatisticsByError()
getProcessInstanceStatisticsByError(
input,
consistencyManagement,
options?): CancelablePromise<IncidentProcessInstanceStatisticsByErrorQueryResult>;
Get process instance statistics by error
Returns statistics for active process instances that currently have active incidents, grouped by incident error hash code.
Parameters
input
IncidentProcessInstanceStatisticsByErrorQuery
consistencyManagement
getProcessInstanceStatisticsByErrorConsistency
options?
Returns
CancelablePromise<IncidentProcessInstanceStatisticsByErrorQueryResult>
Example
async function getProcessInstanceStatisticsByErrorExample() {
const camunda = createCamundaClient();
const result = await camunda.getProcessInstanceStatisticsByError(
{},
{ consistency: { waitUpToMs: 5000 } }
);
for (const stat of result.items ?? []) {
console.log(
`Error: ${stat.errorMessage}, count: ${stat.activeInstancesWithErrorCount}`
);
}
}
Operation Id
getProcessInstanceStatisticsByError
Tags
Incident
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getResource()
getResource(input, options?): CancelablePromise<ResourceResult>;
Get resource
Returns a deployed resource.
Currently, this endpoint only supports RPA resources.
Parameters
input
options?
Returns
CancelablePromise<ResourceResult>
Example
async function getResourceExample(resourceKey: ProcessDefinitionKey) {
const camunda = createCamundaClient();
const resource = await camunda.getResource({
resourceKey,
});
console.log(`Resource: ${resource.resourceName} (${resource.resourceId})`);
}
Operation Id
getResource
Tags
Resource
getResourceContent()
getResourceContent(input, options?): CancelablePromise<string>;
Get resource content
Returns the content of a deployed resource.
Currently, this endpoint only supports RPA resources.
Parameters
input
options?
Returns
CancelablePromise<string>
Example
async function getResourceContentExample(resourceKey: ProcessDefinitionKey) {
const camunda = createCamundaClient();
const content = await camunda.getResourceContent({
resourceKey,
});
console.log(`Content retrieved (type: ${typeof content})`);
}
Operation Id
getResourceContent
Tags
Resource
getRole()
getRole(
input,
consistencyManagement,
options?): CancelablePromise<RoleResult>;
Get role
Get a role by its ID.
Parameters
input
consistencyManagement
options?
Returns
Example
async function getRoleExample() {
const camunda = createCamundaClient();
const role = await camunda.getRole(
{ roleId: "process-admin" },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Role: ${role.name}`);
}
Operation Id
getRole
Tags
Role
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getStartProcessForm()
getStartProcessForm(
input,
consistencyManagement,
options?): CancelablePromise<void | FormResult>;
Get process start form
Get the start form of a process. Note that this endpoint will only return linked forms. This endpoint does not support embedded forms.
Parameters
input
consistencyManagement
getStartProcessFormConsistency
options?
Returns
CancelablePromise<void | FormResult>
Example
async function getStartProcessFormExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const form = await camunda.getStartProcessForm(
{ processDefinitionKey },
{ consistency: { waitUpToMs: 5000 } }
);
if (form) {
console.log(`Form key: ${form.formKey}`);
}
}
Operation Id
getStartProcessForm
Tags
Process definition
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getStatus()
getStatus(options?): CancelablePromise<void>;
Get cluster status
Checks the health status of the cluster by verifying if there's at least one partition with a healthy leader.
Parameters
options?
Returns
CancelablePromise<void>
Example
async function getStatusExample() {
const camunda = createCamundaClient();
await camunda.getStatus();
console.log("Cluster is healthy");
}
Operation Id
getStatus
Tags
Cluster
getSystemConfiguration()
getSystemConfiguration(options?): CancelablePromise<SystemConfigurationResponse>;
System configuration (alpha)
Returns the current system configuration. The response is an envelope that groups settings by feature area.
This endpoint is an alpha feature and may be subject to change in future releases.
Parameters
options?
Returns
CancelablePromise<SystemConfigurationResponse>
Example
async function getSystemConfigurationExample() {
const camunda = createCamundaClient();
const config = await camunda.getSystemConfiguration();
console.log(`Configuration loaded: ${JSON.stringify(config)}`);
}
Operation Id
getSystemConfiguration
Tags
System
getTenant()
getTenant(
input,
consistencyManagement,
options?): CancelablePromise<TenantResult>;
Get tenant
Retrieves a single tenant by tenant ID.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<TenantResult>
Example
async function getTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const tenant = await camunda.getTenant(
{ tenantId },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Tenant: ${tenant.name}`);
}
Operation Id
getTenant
Tags
Tenant
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getTenantClusterVariable()
getTenantClusterVariable(
input,
consistencyManagement,
options?): CancelablePromise<ClusterVariableResult>;
Get a tenant-scoped cluster variable
Get a tenant-scoped cluster variable.
Parameters
input
consistencyManagement
getTenantClusterVariableConsistency
options?
Returns
CancelablePromise<ClusterVariableResult>
Example
async function getTenantClusterVariableExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const variable = await camunda.getTenantClusterVariable(
{
tenantId,
name: "config",
},
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`${variable.name} = ${variable.value}`);
}
Operation Id
getTenantClusterVariable
Tags
Cluster Variable
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getTopology()
getTopology(options?): CancelablePromise<TopologyResponse>;
Get cluster topology
Obtains the current topology of the cluster the gateway is part of.
Parameters
options?
Returns
CancelablePromise<TopologyResponse>
Example
async function getTopologyExample() {
const camunda = createCamundaClient();
const topology = await camunda.getTopology();
console.log(`Cluster size: ${topology.clusterSize}`);
console.log(`Partitions: ${topology.partitionsCount}`);
for (const broker of topology.brokers ?? []) {
console.log(` Broker ${broker.nodeId}: ${broker.host}:${broker.port}`);
}
}
Operation Id
getTopology
Tags
Cluster
getUsageMetrics()
getUsageMetrics(
input,
consistencyManagement,
options?): CancelablePromise<UsageMetricsResponse>;
Get usage metrics
Retrieve the usage metrics based on given criteria.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<UsageMetricsResponse>
Example
async function getUsageMetricsExample() {
const camunda = createCamundaClient();
const metrics = await camunda.getUsageMetrics(
{
startTime: "2025-01-01T00:00:00Z",
endTime: "2025-12-31T23:59:59Z",
},
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Usage metrics retrieved: ${JSON.stringify(metrics)}`);
}
Operation Id
getUsageMetrics
Tags
System
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getUser()
getUser(
input,
consistencyManagement,
options?): CancelablePromise<{
email: string | null;
name: string | null;
username: Username;
}>;
Get user
Get a user by its username.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<{
email: string | null;
name: string | null;
username: Username;
}>
Example
async function getUserExample(username: Username) {
const camunda = createCamundaClient();
const user = await camunda.getUser(
{ username },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`User: ${user.name} (${user.email})`);
}
Operation Id
getUser
Tags
User
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getUserTask()
getUserTask(
input,
consistencyManagement,
options?): CancelablePromise<UserTaskResult>;
Get user task
Get the user task by the user task key.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<UserTaskResult>
Example
async function getUserTaskExample(userTaskKey: UserTaskKey) {
const camunda = createCamundaClient();
const task = await camunda.getUserTask(
{ userTaskKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`Task: ${task.name} (${task.state})`);
}
Operation Id
getUserTask
Tags
User task
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getUserTaskForm()
getUserTaskForm(
input,
consistencyManagement,
options?): CancelablePromise<void | FormResult>;
Get user task form
Get the form of a user task. Note that this endpoint will only return linked forms. This endpoint does not support embedded forms.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<void | FormResult>
Example
async function getUserTaskFormExample(userTaskKey: UserTaskKey) {
const camunda = createCamundaClient();
const form = await camunda.getUserTaskForm(
{ userTaskKey },
{ consistency: { waitUpToMs: 5000 } }
);
if (form) {
console.log(`Form key: ${form.formKey}`);
}
}
Operation Id
getUserTaskForm
Tags
User task
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getVariable()
getVariable(
input,
consistencyManagement,
options?): CancelablePromise<VariableResult>;
Get variable
Get a variable by its key.
This endpoint returns both process-level and local (element-scoped) variables. The variable's scopeKey indicates whether it's a process-level variable or scoped to a specific element instance.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<VariableResult>
Example
async function getVariableExample(variableKey: VariableKey) {
const camunda = createCamundaClient();
const variable = await camunda.getVariable(
{ variableKey },
{ consistency: { waitUpToMs: 5000 } }
);
console.log(`${variable.name} = ${variable.value}`);
}
Operation Id
getVariable
Tags
Variable
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
getWorkers()
getWorkers(): any[];
Return a read-only snapshot of currently registered job workers.
Returns
any[]
logger()
logger(scope?): Logger;
Access a scoped logger (internal & future user emission).
Parameters
scope?
string
Returns
migrateProcessInstance()
migrateProcessInstance(input, options?): CancelablePromise<void>;
Migrate process instance
Migrates a process instance to a new process definition. This request can contain multiple mapping instructions to define mapping between the active process instance's elements and target process definition elements.
Use this to upgrade a process instance to a new version of a process or to a different process definition, e.g. to keep your running instances up-to-date with the latest process improvements.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function migrateProcessInstanceExample(
processInstanceKey: ProcessInstanceKey,
targetProcessDefinitionKey: ProcessDefinitionKey,
sourceElementId: ElementId,
targetElementId: ElementId
) {
const camunda = createCamundaClient();
await camunda.migrateProcessInstance({
processInstanceKey,
targetProcessDefinitionKey,
mappingInstructions: [
{
sourceElementId,
targetElementId,
},
],
});
}
Operation Id
migrateProcessInstance
Tags
Process instance
migrateProcessInstancesBatchOperation()
migrateProcessInstancesBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Migrate process instances (batch)
Migrate multiple process instances. Since only process instances with ACTIVE state can be migrated, any given filters for state are ignored and overridden during this batch operation. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
ProcessInstanceMigrationBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function migrateProcessInstancesBatchOperationExample(
processDefinitionKey: ProcessDefinitionKey,
targetProcessDefinitionKey: ProcessDefinitionKey,
sourceElementId: ElementId,
targetElementId: ElementId
) {
const camunda = createCamundaClient();
const result = await camunda.migrateProcessInstancesBatchOperation({
filter: {
processDefinitionKey,
},
migrationPlan: {
targetProcessDefinitionKey,
mappingInstructions: [
{
sourceElementId,
targetElementId,
},
],
},
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
migrateProcessInstancesBatchOperation
Tags
Process instance
modifyProcessInstance()
modifyProcessInstance(input, options?): CancelablePromise<void>;
Modify process instance
Modifies a running process instance. This request can contain multiple instructions to activate an element of the process or to terminate an active instance of an element.
Use this to repair a process instance that is stuck on an element or took an unintended path. For example, because an external system is not available or doesn't respond as expected.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function modifyProcessInstanceExample(
processInstanceKey: ProcessInstanceKey,
elementId: ElementId,
elementInstanceKey: ElementInstanceKey
) {
const camunda = createCamundaClient();
await camunda.modifyProcessInstance({
processInstanceKey,
activateInstructions: [{ elementId }],
terminateInstructions: [{ elementInstanceKey }],
});
}
Operation Id
modifyProcessInstance
Tags
Process instance
modifyProcessInstancesBatchOperation()
modifyProcessInstancesBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Modify process instances (batch)
Modify multiple process instances. Since only process instances with ACTIVE state can be modified, any given filters for state are ignored and overridden during this batch operation. In contrast to single modification operation, it is not possible to add variable instructions or modify by element key. It is only possible to use the element id of the source and target. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
ProcessInstanceModificationBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function modifyProcessInstancesBatchOperationExample(
processDefinitionKey: ProcessDefinitionKey,
sourceElementId: ElementId,
targetElementId: ElementId
) {
const camunda = createCamundaClient();
const result = await camunda.modifyProcessInstancesBatchOperation({
filter: {
processDefinitionKey,
},
moveInstructions: [
{
sourceElementId,
targetElementId,
},
],
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
modifyProcessInstancesBatchOperation
Tags
Process instance
onAuthHeaders()
onAuthHeaders(h): void;
Parameters
h
(headers) =>
| Record<string, string>
| Promise<Record<string, string>>
Returns
void
pinClock()
pinClock(input, options?): CancelablePromise<void>;
Pin internal clock (alpha)
Set a precise, static time for the Zeebe engine's internal clock. When the clock is pinned, it remains at the specified time and does not advance. To change the time, the clock must be pinned again with a new timestamp.
This endpoint is an alpha feature and may be subject to change in future releases.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function pinClockExample() {
const camunda = createCamundaClient();
await camunda.pinClock({
timestamp: 1735689599000,
});
console.log("Clock pinned");
}
Operation Id
pinClock
Tags
Clock
publishMessage()
publishMessage(input, options?): CancelablePromise<MessagePublicationResult>;
Publish message
Publishes a single message. Messages are published to specific partitions computed from their correlation keys. Messages can be buffered. The endpoint does not wait for a correlation result. Use the message correlation endpoint for such use cases.
Parameters
input
options?
Returns
CancelablePromise<MessagePublicationResult>
Example
async function publishMessageExample() {
const camunda = createCamundaClient();
await camunda.publishMessage({
name: "order-payment-received",
correlationKey: "ORD-12345",
timeToLive: 60000,
variables: {
paymentId: "PAY-123",
},
});
}
Operation Id
publishMessage
Tags
Message
resetClock()
resetClock(options?): CancelablePromise<void>;
Reset internal clock (alpha)
Resets the Zeebe engine's internal clock to the current system time, enabling it to tick in real-time. This operation is useful for returning the clock to normal behavior after it has been pinned to a specific time.
This endpoint is an alpha feature and may be subject to change in future releases.
Parameters
options?
Returns
CancelablePromise<void>
Example
async function resetClockExample() {
const camunda = createCamundaClient();
await camunda.resetClock();
console.log("Clock reset");
}
Operation Id
resetClock
Tags
Clock
resolveIncident()
resolveIncident(input, options?): CancelablePromise<void>;
Resolve incident
Marks the incident as resolved; most likely a call to Update job will be necessary to reset the job's retries, followed by this call.
Parameters
input
options?
Returns
CancelablePromise<void>
Example
async function resolveIncidentExample(incidentKey: IncidentKey) {
const camunda = createCamundaClient();
await camunda.resolveIncident({ incidentKey });
}
Operation Id
resolveIncident
Tags
Incident
resolveIncidentsBatchOperation()
resolveIncidentsBatchOperation(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Resolve related incidents (batch)
Resolves multiple instances of process instances. Since only process instances with ACTIVE state can have unresolved incidents, any given filters for state are ignored and overridden during this batch operation. This is done asynchronously, the progress can be tracked using the batchOperationKey from the response and the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
ProcessInstanceIncidentResolutionBatchOperationRequest
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function resolveIncidentsBatchOperationExample(
processDefinitionKey: ProcessDefinitionKey
) {
const camunda = createCamundaClient();
const result = await camunda.resolveIncidentsBatchOperation({
filter: {
processDefinitionKey,
},
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
resolveIncidentsBatchOperation
Tags
Process instance
resolveProcessInstanceIncidents()
resolveProcessInstanceIncidents(input, options?): CancelablePromise<BatchOperationCreatedResult>;
Resolve related incidents
Creates a batch operation to resolve multiple incidents of a process instance.
Parameters
input
resolveProcessInstanceIncidentsInput
options?
Returns
CancelablePromise<BatchOperationCreatedResult>
Example
async function resolveProcessInstanceIncidentsExample(
processInstanceKey: ProcessInstanceKey
) {
const camunda = createCamundaClient();
const result = await camunda.resolveProcessInstanceIncidents({
processInstanceKey,
});
console.log(`Batch operation key: ${result.batchOperationKey}`);
}
Operation Id
resolveProcessInstanceIncidents
Tags
Process instance
resumeBatchOperation()
resumeBatchOperation(input, options?): CancelablePromise<void>;
Resume Batch operation
Resumes a suspended batch operation. This is done asynchronously, the progress can be tracked using the batch operation status endpoint (/batch-operations/{batchOperationKey}).
Parameters
input
batchOperationKey
options?
Returns
CancelablePromise<void>
Example
async function resumeBatchOperationExample(
batchOperationKey: BatchOperationKey
) {
const camunda = createCamundaClient();
await camunda.resumeBatchOperation({ batchOperationKey });
}
Operation Id
resumeBatchOperation
Tags
Batch operation
searchAuditLogs()
searchAuditLogs(
input,
consistencyManagement,
options?): CancelablePromise<AuditLogSearchQueryResult>;
Search audit logs
Search for audit logs based on given criteria.
Parameters
input
consistencyManagement
options?
Returns
CancelablePromise<AuditLogSearchQueryResult>
Example
async function searchAuditLogsExample() {
const camunda = createCamundaClient();
const result = await camunda.searchAuditLogs(
{
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const log of result.items ?? []) {
console.log(`${log.auditLogKey}: ${log.operationType}`);
}
}
Operation Id
searchAuditLogs
Tags
Audit Log
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchAuthorizations()
searchAuthorizations(
input,
consistencyManagement,
options?): CancelablePromise<AuthorizationSearchResult>;
Search authorizations
Search for authorizations based on given criteria.
Parameters
input
consistencyManagement
searchAuthorizationsConsistency
options?
Returns
CancelablePromise<AuthorizationSearchResult>
Example
async function searchAuthorizationsExample() {
const camunda = createCamundaClient();
const result = await camunda.searchAuthorizations(
{
filter: { ownerType: "USER" },
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const auth of result.items ?? []) {
console.log(
`${auth.authorizationKey}: ${auth.ownerId} - ${auth.resourceType}`
);
}
}
Operation Id
searchAuthorizations
Tags
Authorization
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchBatchOperationItems()
searchBatchOperationItems(
input,
consistencyManagement,
options?): CancelablePromise<BatchOperationItemSearchQueryResult>;
Search batch operation items
Search for batch operation items based on given criteria.
Parameters
input
consistencyManagement
searchBatchOperationItemsConsistency
options?
Returns
CancelablePromise<BatchOperationItemSearchQueryResult>
Example
async function searchBatchOperationItemsExample() {
const camunda = createCamundaClient();
const result = await camunda.searchBatchOperationItems(
{
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const item of result.items ?? []) {
console.log(`Item: ${item.itemKey} (${item.state})`);
}
}
Operation Id
searchBatchOperationItems
Tags
Batch operation
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchBatchOperations()
searchBatchOperations(
input,
consistencyManagement,
options?): CancelablePromise<BatchOperationSearchQueryResult>;
Search batch operations
Search for batch operations based on given criteria.
Parameters
input
consistencyManagement
searchBatchOperationsConsistency
options?
Returns
CancelablePromise<BatchOperationSearchQueryResult>
Example
async function searchBatchOperationsExample() {
const camunda = createCamundaClient();
const result = await camunda.searchBatchOperations(
{
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const batch of result.items ?? []) {
console.log(
`${batch.batchOperationKey}: ${batch.batchOperationType} (${batch.state})`
);
}
}
Operation Id
searchBatchOperations
Tags
Batch operation
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchClientsForGroup()
searchClientsForGroup(
input,
consistencyManagement,
options?): CancelablePromise<SearchQueryResponse & object>;
Search group clients
Search clients assigned to a group.
Parameters
input
consistencyManagement
searchClientsForGroupConsistency
options?
Returns
CancelablePromise<SearchQueryResponse & object>
Example
async function searchClientsForGroupExample() {
const camunda = createCamundaClient();
const result = await camunda.searchClientsForGroup(
{ groupId: "engineering-team" },
{ consistency: { waitUpToMs: 5000 } }
);
for (const client of result.items ?? []) {
console.log(`Client: ${client.clientId}`);
}
}
Operation Id
searchClientsForGroup
Tags
Group
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchClientsForRole()
searchClientsForRole(
input,
consistencyManagement,
options?): CancelablePromise<SearchQueryResponse & object>;
Search role clients
Search clients with assigned role.
Parameters
input
consistencyManagement
searchClientsForRoleConsistency
options?
Returns
CancelablePromise<SearchQueryResponse & object>
Example
async function searchClientsForRoleExample() {
const camunda = createCamundaClient();
const result = await camunda.searchClientsForRole(
{ roleId: "process-admin" },
{ consistency: { waitUpToMs: 5000 } }
);
for (const client of result.items ?? []) {
console.log(`Client: ${client.clientId}`);
}
}
Operation Id
searchClientsForRole
Tags
Role
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchClientsForTenant()
searchClientsForTenant(
input,
consistencyManagement,
options?): CancelablePromise<SearchQueryResponse & object>;
Search clients for tenant
Retrieves a filtered and sorted list of clients for a specified tenant.
Parameters
input
consistencyManagement
searchClientsForTenantConsistency
options?
Returns
CancelablePromise<SearchQueryResponse & object>
Example
async function searchClientsForTenantExample(tenantId: TenantId) {
const camunda = createCamundaClient();
const result = await camunda.searchClientsForTenant(
{ tenantId },
{ consistency: { waitUpToMs: 5000 } }
);
for (const client of result.items ?? []) {
console.log(`Client: ${client.clientId}`);
}
}
Operation Id
searchClientsForTenant
Tags
Tenant
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchClusterVariables()
searchClusterVariables(
input,
consistencyManagement,
options?): CancelablePromise<ClusterVariableSearchQueryResult>;
Search for cluster variables based on given criteria. By default, long variable values in the response are truncated.
Parameters
input
consistencyManagement
searchClusterVariablesConsistency
options?
Returns
CancelablePromise<ClusterVariableSearchQueryResult>
Example
async function searchClusterVariablesExample() {
const camunda = createCamundaClient();
const result = await camunda.searchClusterVariables(
{
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const variable of result.items ?? []) {
console.log(`${variable.name} = ${variable.value}`);
}
}
Operation Id
searchClusterVariables
Tags
Cluster Variable
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
searchCorrelatedMessageSubscriptions()
searchCorrelatedMessageSubscriptions(
input,
consistencyManagement,
options?): CancelablePromise<CorrelatedMessageSubscriptionSearchQueryResult>;
Search correlated message subscriptions
Search correlated message subscriptions based on given criteria.
Parameters
input
CorrelatedMessageSubscriptionSearchQuery
consistencyManagement
searchCorrelatedMessageSubscriptionsConsistency
options?
Returns
CancelablePromise<CorrelatedMessageSubscriptionSearchQueryResult>
Example
async function searchCorrelatedMessageSubscriptionsExample() {
const camunda = createCamundaClient();
const result = await camunda.searchCorrelatedMessageSubscriptions(
{
page: { limit: 10 },
},
{ consistency: { waitUpToMs: 5000 } }
);
for (const sub of result.items ?? []) {
console.log(`Correlated subscription: ${sub.messageName}`);
}
}
Operation Id
searchCorrelatedMessageSubscriptions
Tags
Message subscription
Consistency
eventual - this endpoint is backed by data that is eventually consistent with the system state.
[...]
